use clap::{arg, Command, Arg, ArgAction, value_parser};
use indicatif::{ProgressBar, ProgressStyle};
use tokio::fs::{File, self};
use std::collections::HashMap;
use std::path::{PathBuf, Path};

use console::Term;
use console::style;

use reqwest::{self, Response};
use reqwest::multipart::{Form, Part};

#[tokio::main]
async fn main() {
    // Initialise Terminal outputs
    let term = Term::stdout();

    // Debug defaults to off
    let mut debug = false;

    let matches = Command::new("SUpload")
        .version("0.1.0")
        .author("Volkor <me@volkor.me>")
        .about("A simple screenshot and file uploading program.")
        .arg(Arg::new("file").action(ArgAction::Append).help("Specified file to upload, not needed if using screenshot or screencast").required(false).value_parser(value_parser!(PathBuf)))
        .arg(Arg::new("domain").short('d').long("domain").help("Overrides the domain.").required(false))
        .arg(Arg::new("browser").short('o').long("open-browser").help("Opens the browser on successful upload.").required(false))
        .arg(Arg::new("screenshot").short('s').long("screenshot").help("Opens a compatible screenshot program, and uploads that.").required(false))
        .arg(Arg::new("screencast").short('g').long("screencast").help("Opens a compatible screen recorder, and uploads that.").required(false))
        .arg(arg!(-v --verbose "Log more information to the terminal"))
        .subcommand(
            // Changes settings in the config
            Command::new("config")
                        .about("Interact with the config")
                        .arg(Arg::new("set").short('s').long("set"))
        )
        .get_matches();

        // Turn on debug mode
        if matches
        .get_one::<bool>("verbose")
        .expect("Count's are defaulted") == &true {
            debug = true;
            println!("{}", style("DEBUG: Verbose Logging enabled").dim());
        }
        
        // Grab the file_path if set.
        if let Some(file_path) = matches.get_one::<PathBuf>("file") {
            if debug {
                 println!("{} {}", style("DEBUG: File Path:  ").dim(), style(file_path.display()).dim());
            }
        // Upload the file
        upload_file(file_path.to_path_buf());
        }
}

// Uploads the file, matching 
async fn upload_file(file_path: PathBuf) {
    println!("{}", style("DEBUG: Entered upload_file function").dim());

    // Grab the filesize of the file to be uploaded (for progress bar tracking!)
    let filesize = fs::metadata(&file_path).await.unwrap().len() as i32;

}

// Parses the response from the upload.

async fn parse_response() {
    todo!()
}

async fn open_browser() {
    todo!()
}
